%global     snapdate         	20120923
%global     derelict_revision	b4f810c
%global     alphatag         	%{snapdate}git%{derelict_revision}

%define add_subpackage(n:)                                                    \
%package %{-n*}                                                               \
Summary:        Libraries to use %{-n*}                                       \
Summary(fr):    Bibliothèque pour utiliser %{-n*}                             \
Requires:       %{name}%{?_isa} =  %{version}-%{release}                      \
Requires:       %*                                                            \
%description %{-n*}                                                           \
Libraries for %{-n*} to use in D programming language.                        \
%description -l fr %{-n*}                                                     \
Bibliothèque pour %{-n*} à utiliser en langage D.                             \
%package %{-n*}-devel                                                         \
Summary:        Header files and libraries for %{-n*}                         \
Summary(fr):    Fichier d'entête et bibliothèque pour %{-n*}                  \
Requires:       %{name}%{?_isa} =  %{version}-%{release}                      \
Requires:       %*                                                            \
%description %{-n*}-devel                                                     \
Header files and libraries for %{-n*} to use in D programming language.       \
%description -l fr %{-n*}-devel                                               \
Fichier d'entête et bibliothèque pour %{-n*} à utiliser en langage D.         \
%{nil}

%define add_files(n:)                                                         \
%post  %{-n*} -p  /sbin/ldconfig                                              \
%postun %{-n*} -p  /sbin/ldconfig                                             \
%files %{-n*}                                                                 \
%{_libdir}/libDerelict%1.so.3                                                 \
%{_libdir}/libDerelict%1.so.3.0.0                                             \
%files %{-n*}-devel                                                           \
%{_libdir}/libDerelict%1.so                                                   \
%{_d_includedir}/%{name}/%2                                                   \
%{nil}

# The source for this package was pulled from upstream's git.
# Use the following commands to generate the tarball:
# git clone git://github.com/aldacron/Derelict3.git
# cd derelict; 
# git rev-parse --short HEAD            -> for derelict_revision
# git checkout %%derelict_rev 
# git archive --prefix=derelict-%%{alphatag}/ HEAD --format=tar | xz > ../derelict-%%{alphatag}.tar.xz

Name:           derelict
Version:        3
Release:        2.%{alphatag}%{?dist}
Summary:        Collection of D bindings to C shared libraries
Summary(fr):    Collection de bibliothèque en D interfaçant des bibliothèques dynamiques en C 

License:        Boost 
URL:            http://www.dsource.org/projects/
Source0:        %{name}-%{alphatag}.tar.xz
BuildRequires:  ldc, ldc-phobos-devel


%description
derelict supports some useful features for project development, including:
- Cross-Platform Consistency
derelict loads shared libraries manually at run-time and throws an exception
when the library, or any symbol in the library, fails to load. This gives you
complete control over how to handle the case of a missing shared library. You
can fall back to a different code path, give your users a helpful error message
or take any action you want. Regardless, you have consistent behavior across
multiple platforms. 
- Selective Symbol Loading - This feature allows you to override exceptions
thrown by derelict when a shared library symbol fails to load. It is a goal of
the project that each derelict package be updated from time-to-time to load the
latest version of each library. Often, new library versions include new
functions. If a user has an older version of the library installed, one that is
missing the new function symbols, derelict will notice and throw an exception.
By making use of Selective Symbol Loading, you can override this behavior and
allow the older library version to load successfully. 

%description -l fr
derelict soutient quelques dispositifs utiles pour le développement de projet
incluant :
- Uniformité du code portable sur plusieurs plates-formes 
Derelict charge les bibliothèques partagées manuellement au temps d'exécution
et
renvoie une exception quand une bibliothèque, ou n'importe quel symbole dans la
bibliothèque, ne charge pas. Ceci vous donne le contrôle complet sur la façon
de traiter le cas où une bibliothèque partagée ne chargerait pas. Vous pouvez
retomber à un chemin différent de code, donner à vos utilisateurs un message
d'erreur utile ou prendre n'importe quelle mesure que vous voulez. Sans avoir
à vous soucier d'un comportement identique à travers de multiples
plates-formes.
- Chargement sélectif de symbole - ce dispositif vous permet de surcharger des
exceptions renvoyées par derelict quand un symbole de bibliothèque partagée ne
charge pas. C'est un but du projet que le paquet derelict soit mis à jour afin
de charger la dernière version de chaque bibliothèque. Souvent, les nouvelles
versions de bibliothèque incluent de nouvelles fonctions. Si un utilisateur a
une version plus ancienne de la bibliothèque installée, ou une à laquelle il
manque les nouveaux symboles d'une fonction, derelict le notera et renverra une
exception. En se servant du chargement sélectif des symboles, vous pouvez
dépasser
ce comportement et permettre à la version la plus ancienne de derelict de se
charger avec succès.

%package devel
Summary:        Header files and libraries for derelict
Summary(fr):    Fichier d'entête et bibliothèque pour derelict
Requires:       %{name}%{?_isa} =  %{version}-%{release}
BuildRequires:  geany

%description devel
Header files and libraries for derelict to use in D programming language.
%description -l fr devel
Fichier d'entête et bibliothèque pour derelict à utiliser en langage D.

%add_subpackage -n gl mesa-libGL mesa-libGLU mesa-libGLw
%add_subpackage -n glfw glfw
%add_subpackage -n DevIL DevIL DevIL-ILUT
%add_subpackage -n openAL openal-soft
%add_subpackage -n alure alure
%add_subpackage -n freetype freetype
%add_subpackage -n SDL SDL SDL_image SDL_mixer SDL_net SDL_sound SDL_ttf SDL_gfx
%add_subpackage -n ode ode
%add_subpackage -n assimp assimp
%add_subpackage -n freeglut freeglut
%add_subpackage -n freeimage freeimage
%add_subpackage -n sfml SFML


%prep
%setup -q -n %{name}-%{alphatag}
# temp geany config directory for allow geany to generate tags
mkdir -p geany_config
sed -i "s/ldc2 /ldc2 -g /g" build/build.d

%build
# build the builder
pushd build
ldc2 %{_d_optflags} -d-version=Shared build.d 
# build derelict
./derelict
popd
# generate geany tags
geany -c geany_config -g derelict.d.tags $(find import/%{name} -name "*.d")

%install
mkdir -p    %{buildroot}%{_datadir}/geany/tags/
mkdir -p    %{buildroot}%{_d_includedir}/%{name}
mkdir -p    %{buildroot}%{_libdir}
# install derelict headers
cp -rp      import/%{name}/* %{buildroot}%{_d_includedir}/%{name}/
# install derelict libs
cp -p       lib/*so.3.0.0            %{buildroot}%{_libdir}/
pushd %{buildroot}%{_libdir}/
for lib in lib*.so.3.0.0; do
    ln -s $lib  $(basename $lib .0.0) 
    ln -s $(basename $lib .0.0) $(basename $lib .3.0.0)
done
popd
# install geany tags
install -m0644 derelict.d.tags %{buildroot}/%{_datadir}/geany/tags/

%post   -p  /sbin/ldconfig
%postun -p  /sbin/ldconfig

%files
%doc README.markdown
%{_d_includedir}/%{name}
%{_datadir}/geany/tags/derelict.d.tags
%{_libdir}/libDerelictUtil.so.3
%{_libdir}/libDerelictUtil.so.3.0.0
%files devel
%{_libdir}/libDerelictUtil.so 
%{_d_includedir}/%{name}/util

%add_files -n gl GL3 opengl3
%add_files -n glfw GLFW3 glfw3
%add_files -n DevIL IL devil
%add_files -n openAL AL openal
%add_files -n alure ALURE alure
%add_files -n freetype FT freetype
%add_files -n SDL SDL2 sdl2
%add_files -n ode ODE ode
%add_files -n assimp ASSIMP assimp
%add_files -n freeglut FG freeglut
%add_files -n freeimage FI freeimage
%add_files -n sfml SFML2 sfml2


%changelog
* Tue Aug 14 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 3-2.20120811git8bcc53b
- update to newest release Derelict 3

* Wed Feb 01 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-22.20111106svn593
- rebuild dmdfe 2.059

* Wed Feb 01 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-21.20111106svn593
- fix broken dependencies

* Thu Jan 19 2012 Jonathan MERCIER <bioinfornatics at gmail.com> - 2-20.20111106svn593
- Fix summary

* Fri Jan 12 2012 Jonathan MERCIER <bioinfornatics at gmail.com> 2-19.20111106svn593
- merge static subpackage with corresponding dvel subpackage for follow Packaging Static Libraries Guidelines

* Sat Jan 7 2012  Jonathan MERCIER <bioinfornatics at gmail.com> 2-18.20111106svn593
- Fix misspellling in description
- put devel dependencies for devel subpackage
- Fix end of line in css file

* Fri Jan 6 2012  Jonathan MERCIER <bioinfornatics at gmail.com> 2-17.20111106svn593
- fix license in spec file (Boost  not GPLv3+)

* Sat Dec 31 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-16.20111106svn593
- fix typo in spec file

* Mon Dec 19 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2-15.20111106svn593
- Remove BuildRoot Tag
- Remove extra target DerelictFT for make they are already DerelictFT_ALL
- Remove DdocTodevhelp
- %%doc owns doc/*
- fix changelog

* Tue Dec 14 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2-14.20111106svn593
- Remove devhelp package it is useless
- Update to revision 593

* Sun Dec 11 2011 Jonathan MERCIER <bioinfornatics at gmail.com> 2-13.20111031svn591
- fix buildrequires and require
- remove %%defattr and Group section

* Fri Dec 9 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-12.20111031svn591
- Add doc for devhelp
- Add tag for geany

* Sat Nov 12 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-11.20111031svn591
- Update to revision 591

* Sat Aug 06 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-11.20111024svn590
- Update to revision 590

* Sat Aug 06 2011  Jonathan MERCIER <bioinfornatics at gmail.com> 2-10.20110806svn582
- Update to revision 582

* Wed Dec 08 2010  Jonathan MERCIER <bioinfornatics at gmail.com> 2-9.20101207svn521
- Update to revision 521

* Mon Dec 06 2010  Jonathan MERCIER <bioinfornatics at gmail.com> 2-8.20101201svn519
- Update to revision 519

* Wed Sep 15 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-7.20100824svn513
- remove \x0a character by a real newline

* Mon Sep 13 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-6.20100824svn513
- Fix spec add require and build require

* Sun Sep 12 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-5.20100824svn513
- Fix spec

* Thu Aug 26 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-4.20100824svn513
- update to release 513

* Wed Aug 11 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-3.20100801svn499
- remove debuginfo package because it is a static librarie
- Update to new revision 499

* Tue Aug 03 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-2.20100801svn495
- Update to new revision 495

* Sun Aug 01 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-2.20100801svn493
- Update to new revision 493

* Sat Jul 31 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-2.20100407svn490
- use %%{_libdir}

* Sun Jul 04 2010 Jonathan MERCIER <bioinfornatics at gmail.com> 2-1.20100407svn490
- Initial release
